# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AppMetricsInfo(BaseModel):
    """
    AppMetricsInfo
    """ # noqa: E501
    pos_1: Optional[StrictInt] = Field(default=None, description="number of organic SERPs where the product ranks #1")
    pos_2_3: Optional[StrictInt] = Field(default=None, description="number of organic SERPs where the product ranks #2-3")
    pos_4_10: Optional[StrictInt] = Field(default=None, description="number of organic SERPs where the product ranks #4-10")
    pos_11_100: Optional[StrictInt] = Field(default=None, description="number of organic SERPs where the product ranks #11-100")
    count: Optional[StrictInt] = Field(default=None, description="total count of Amazon organic SERPs that contain the product")
    search_volume: Optional[StrictInt] = Field(default=None, description="total search volume of the product’s ranking keywords in organic SERP")
    __properties: ClassVar[List[str]] = ["pos_1", "pos_2_3", "pos_4_10", "pos_11_100", "count", "search_volume"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AppMetricsInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if pos_1 (nullable) is None
        # and model_fields_set contains the field
        if self.pos_1 is None and "pos_1" in self.model_fields_set:
            _dict['pos_1'] = None

        # set to None if pos_2_3 (nullable) is None
        # and model_fields_set contains the field
        if self.pos_2_3 is None and "pos_2_3" in self.model_fields_set:
            _dict['pos_2_3'] = None

        # set to None if pos_4_10 (nullable) is None
        # and model_fields_set contains the field
        if self.pos_4_10 is None and "pos_4_10" in self.model_fields_set:
            _dict['pos_4_10'] = None

        # set to None if pos_11_100 (nullable) is None
        # and model_fields_set contains the field
        if self.pos_11_100 is None and "pos_11_100" in self.model_fields_set:
            _dict['pos_11_100'] = None

        # set to None if count (nullable) is None
        # and model_fields_set contains the field
        if self.count is None and "count" in self.model_fields_set:
            _dict['count'] = None

        # set to None if search_volume (nullable) is None
        # and model_fields_set contains the field
        if self.search_volume is None and "search_volume" in self.model_fields_set:
            _dict['search_volume'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AppMetricsInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pos_1": obj.get("pos_1"),
            "pos_2_3": obj.get("pos_2_3"),
            "pos_4_10": obj.get("pos_4_10"),
            "pos_11_100": obj.get("pos_11_100"),
            "count": obj.get("count"),
            "search_volume": obj.get("search_volume")
        })
        return _obj


