# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dataforseo_client.models.appendix_status_endpoints_info import AppendixStatusEndpointsInfo
from typing import Optional, Set
from typing_extensions import Self

class AppendixStatusResultInfo(BaseModel):
    """
    AppendixStatusResultInfo
    """ # noqa: E501
    api: Optional[StrictStr] = Field(default=None, description="name of the API the list of APIs: serp keywords_data appendix dataforseo_labs domain_analytics merchant on_page business_data backlinks app_data content_analysis content_generation")
    status: Optional[StrictStr] = Field(default=None, description="current status you can find all information about your API statuses for the last 60 days here the list of possible current statuses: major_outage partial_outage long_response_time long_execution_time webhook_delay send_delay")
    endpoints: Optional[List[AppendixStatusEndpointsInfo]] = Field(default=None, description="array of objects that contain status information for API endpoints")
    __properties: ClassVar[List[str]] = ["api", "status", "endpoints"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AppendixStatusResultInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in endpoints (list)
        _items = []
        if self.endpoints:
            for _item in self.endpoints:
                if _item:
                    _items.append(_item.to_dict())
            _dict['endpoints'] = _items
        # set to None if api (nullable) is None
        # and model_fields_set contains the field
        if self.api is None and "api" in self.model_fields_set:
            _dict['api'] = None

        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        # set to None if endpoints (nullable) is None
        # and model_fields_set contains the field
        if self.endpoints is None and "endpoints" in self.model_fields_set:
            _dict['endpoints'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AppendixStatusResultInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "api": obj.get("api"),
            "status": obj.get("status"),
            "endpoints": [AppendixStatusEndpointsInfo.from_dict(_item) for _item in obj["endpoints"]] if obj.get("endpoints") is not None else None
        })
        return _obj


