# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from dataforseo_client.models.base_on_page_resource_item_info import BaseOnPageResourceItemInfo
from dataforseo_client.models.cache_control import CacheControl
from dataforseo_client.models.last_modified import LastModified
from dataforseo_client.models.on_page_resource_issue_info import OnPageResourceIssueInfo
from dataforseo_client.models.page_meta_info import PageMetaInfo
from dataforseo_client.models.page_timing import PageTiming
from typing import Optional, Set
from typing_extensions import Self

class OnPageHtmlResourceElementItem(BaseOnPageResourceItemInfo):
    """
    OnPageHtmlResourceElementItem
    """ # noqa: E501
    status_code: Optional[StrictInt] = Field(default=None, description="status code of the page")
    location: Optional[StrictStr] = Field(default=None, description="location header indicates the URL to redirect a page to")
    url: Optional[StrictStr] = Field(default=None, description="page URL")
    meta: Optional[PageMetaInfo] = None
    page_timing: Optional[PageTiming] = None
    onpage_score: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="shows how page is optimized on a 100-point scale this field shows how page is optimized considering critical on-page issues and warnings detected; 100 is the highest possible score that means the page does not have any critical on-page issues and important warnings; learn more about how the metric is calculated in this help center article")
    total_dom_size: Optional[StrictInt] = Field(default=None, description="total DOM size of a page")
    custom_js_response: Optional[Dict[str, Any]] = Field(default=None, description="the result of executing a specified JS script note that you should specify a custom_js field when setting a task to receive this data and the field type and its value will totally depend on the script you specified;you can also filter the results by this value specifying filters in the following way: [\"custom_js_response.url\", \"like\", \"pixel\"]")
    resource_errors: Optional[OnPageResourceIssueInfo] = None
    broken_resources: Optional[StrictBool] = Field(default=None, description="indicates whether a page contains broken resources")
    broken_links: Optional[StrictBool] = Field(default=None, description="indicates whether a page contains broken links")
    duplicate_title: Optional[StrictBool] = Field(default=None, description="indicates whether a page has duplicate title tags")
    duplicate_description: Optional[StrictBool] = Field(default=None, description="indicates whether a page has a duplicate description")
    duplicate_content: Optional[StrictBool] = Field(default=None, description="indicates whether a page has duplicate content")
    click_depth: Optional[StrictInt] = Field(default=None, description="number of clicks it takes to get to the page indicates the number of clicks from the homepage needed before landing at the target page")
    size: Optional[StrictInt] = Field(default=None, description="resource size indicates the size of a given page measured in bytes")
    encoded_size: Optional[StrictInt] = Field(default=None, description="page size after encoding indicates the size of the encoded page measured in bytes")
    total_transfer_size: Optional[StrictInt] = Field(default=None, description="compressed page size indicates the compressed size of a given page")
    fetch_time: Optional[StrictStr] = Field(default=None, description="date and time when a resource was fetched in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00” example: 2019-11-15 12:57:46 +00:00")
    cache_control: Optional[CacheControl] = None
    checks: Optional[Dict[str, Optional[StrictBool]]] = Field(default=None, description="website checks on-page check-ups related to the page")
    content_encoding: Optional[StrictStr] = Field(default=None, description="type of encoding")
    media_type: Optional[StrictStr] = Field(default=None, description="types of media used to display a page")
    server: Optional[StrictStr] = Field(default=None, description="server version")
    is_resource: Optional[StrictBool] = Field(default=None, description="indicates whether a page is a single resource")
    url_length: Optional[StrictInt] = Field(default=None, description="page URL length in characters")
    relative_url_length: Optional[StrictInt] = Field(default=None, description="relative URL length in characters")
    last_modified: Optional[LastModified] = None
    __properties: ClassVar[List[str]] = ["resource_type", "status_code", "location", "url", "meta", "page_timing", "onpage_score", "total_dom_size", "custom_js_response", "resource_errors", "broken_resources", "broken_links", "duplicate_title", "duplicate_description", "duplicate_content", "click_depth", "size", "encoded_size", "total_transfer_size", "fetch_time", "cache_control", "checks", "content_encoding", "media_type", "server", "is_resource", "url_length", "relative_url_length", "last_modified"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OnPageHtmlResourceElementItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of meta
        if self.meta:
            _dict['meta'] = self.meta.to_dict()
        # override the default output from pydantic by calling `to_dict()` of page_timing
        if self.page_timing:
            _dict['page_timing'] = self.page_timing.to_dict()
        # override the default output from pydantic by calling `to_dict()` of resource_errors
        if self.resource_errors:
            _dict['resource_errors'] = self.resource_errors.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cache_control
        if self.cache_control:
            _dict['cache_control'] = self.cache_control.to_dict()
        # override the default output from pydantic by calling `to_dict()` of last_modified
        if self.last_modified:
            _dict['last_modified'] = self.last_modified.to_dict()
        # set to None if resource_type (nullable) is None
        # and model_fields_set contains the field
        if self.resource_type is None and "resource_type" in self.model_fields_set:
            _dict['resource_type'] = None

        # set to None if status_code (nullable) is None
        # and model_fields_set contains the field
        if self.status_code is None and "status_code" in self.model_fields_set:
            _dict['status_code'] = None

        # set to None if location (nullable) is None
        # and model_fields_set contains the field
        if self.location is None and "location" in self.model_fields_set:
            _dict['location'] = None

        # set to None if url (nullable) is None
        # and model_fields_set contains the field
        if self.url is None and "url" in self.model_fields_set:
            _dict['url'] = None

        # set to None if onpage_score (nullable) is None
        # and model_fields_set contains the field
        if self.onpage_score is None and "onpage_score" in self.model_fields_set:
            _dict['onpage_score'] = None

        # set to None if total_dom_size (nullable) is None
        # and model_fields_set contains the field
        if self.total_dom_size is None and "total_dom_size" in self.model_fields_set:
            _dict['total_dom_size'] = None

        # set to None if custom_js_response (nullable) is None
        # and model_fields_set contains the field
        if self.custom_js_response is None and "custom_js_response" in self.model_fields_set:
            _dict['custom_js_response'] = None

        # set to None if broken_resources (nullable) is None
        # and model_fields_set contains the field
        if self.broken_resources is None and "broken_resources" in self.model_fields_set:
            _dict['broken_resources'] = None

        # set to None if broken_links (nullable) is None
        # and model_fields_set contains the field
        if self.broken_links is None and "broken_links" in self.model_fields_set:
            _dict['broken_links'] = None

        # set to None if duplicate_title (nullable) is None
        # and model_fields_set contains the field
        if self.duplicate_title is None and "duplicate_title" in self.model_fields_set:
            _dict['duplicate_title'] = None

        # set to None if duplicate_description (nullable) is None
        # and model_fields_set contains the field
        if self.duplicate_description is None and "duplicate_description" in self.model_fields_set:
            _dict['duplicate_description'] = None

        # set to None if duplicate_content (nullable) is None
        # and model_fields_set contains the field
        if self.duplicate_content is None and "duplicate_content" in self.model_fields_set:
            _dict['duplicate_content'] = None

        # set to None if click_depth (nullable) is None
        # and model_fields_set contains the field
        if self.click_depth is None and "click_depth" in self.model_fields_set:
            _dict['click_depth'] = None

        # set to None if size (nullable) is None
        # and model_fields_set contains the field
        if self.size is None and "size" in self.model_fields_set:
            _dict['size'] = None

        # set to None if encoded_size (nullable) is None
        # and model_fields_set contains the field
        if self.encoded_size is None and "encoded_size" in self.model_fields_set:
            _dict['encoded_size'] = None

        # set to None if total_transfer_size (nullable) is None
        # and model_fields_set contains the field
        if self.total_transfer_size is None and "total_transfer_size" in self.model_fields_set:
            _dict['total_transfer_size'] = None

        # set to None if fetch_time (nullable) is None
        # and model_fields_set contains the field
        if self.fetch_time is None and "fetch_time" in self.model_fields_set:
            _dict['fetch_time'] = None

        # set to None if checks (nullable) is None
        # and model_fields_set contains the field
        if self.checks is None and "checks" in self.model_fields_set:
            _dict['checks'] = None

        # set to None if content_encoding (nullable) is None
        # and model_fields_set contains the field
        if self.content_encoding is None and "content_encoding" in self.model_fields_set:
            _dict['content_encoding'] = None

        # set to None if media_type (nullable) is None
        # and model_fields_set contains the field
        if self.media_type is None and "media_type" in self.model_fields_set:
            _dict['media_type'] = None

        # set to None if server (nullable) is None
        # and model_fields_set contains the field
        if self.server is None and "server" in self.model_fields_set:
            _dict['server'] = None

        # set to None if is_resource (nullable) is None
        # and model_fields_set contains the field
        if self.is_resource is None and "is_resource" in self.model_fields_set:
            _dict['is_resource'] = None

        # set to None if url_length (nullable) is None
        # and model_fields_set contains the field
        if self.url_length is None and "url_length" in self.model_fields_set:
            _dict['url_length'] = None

        # set to None if relative_url_length (nullable) is None
        # and model_fields_set contains the field
        if self.relative_url_length is None and "relative_url_length" in self.model_fields_set:
            _dict['relative_url_length'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OnPageHtmlResourceElementItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "resource_type": obj.get("resource_type"),
            "status_code": obj.get("status_code"),
            "location": obj.get("location"),
            "url": obj.get("url"),
            "meta": PageMetaInfo.from_dict(obj["meta"]) if obj.get("meta") is not None else None,
            "page_timing": PageTiming.from_dict(obj["page_timing"]) if obj.get("page_timing") is not None else None,
            "onpage_score": obj.get("onpage_score"),
            "total_dom_size": obj.get("total_dom_size"),
            "custom_js_response": obj.get("custom_js_response"),
            "resource_errors": OnPageResourceIssueInfo.from_dict(obj["resource_errors"]) if obj.get("resource_errors") is not None else None,
            "broken_resources": obj.get("broken_resources"),
            "broken_links": obj.get("broken_links"),
            "duplicate_title": obj.get("duplicate_title"),
            "duplicate_description": obj.get("duplicate_description"),
            "duplicate_content": obj.get("duplicate_content"),
            "click_depth": obj.get("click_depth"),
            "size": obj.get("size"),
            "encoded_size": obj.get("encoded_size"),
            "total_transfer_size": obj.get("total_transfer_size"),
            "fetch_time": obj.get("fetch_time"),
            "cache_control": CacheControl.from_dict(obj["cache_control"]) if obj.get("cache_control") is not None else None,
            "checks": obj.get("checks"),
            "content_encoding": obj.get("content_encoding"),
            "media_type": obj.get("media_type"),
            "server": obj.get("server"),
            "is_resource": obj.get("is_resource"),
            "url_length": obj.get("url_length"),
            "relative_url_length": obj.get("relative_url_length"),
            "last_modified": LastModified.from_dict(obj["last_modified"]) if obj.get("last_modified") is not None else None
        })
        return _obj


