# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dataforseo_client.models.base_business_data_serp_element_item import BaseBusinessDataSerpElementItem
from dataforseo_client.models.rating_info import RatingInfo
from typing import Optional, Set
from typing_extensions import Self

class TripadvisorSearchOrganicBusinessDataSerpElementItem(BaseBusinessDataSerpElementItem):
    """
    TripadvisorSearchOrganicBusinessDataSerpElementItem
    """ # noqa: E501
    rank_group: Optional[StrictInt] = Field(default=None, description="position within a group of elements with identical type values positions of elements with different type values are omitted from rank_group")
    rank_absolute: Optional[StrictInt] = Field(default=None, description="absolute rank among all the listed results absolute position among all reviews on the list")
    title: Optional[StrictStr] = Field(default=None, description="name of the business entity")
    url_path: Optional[StrictStr] = Field(default=None, description="URL path of the business entity URL path to the Tripadvisor page of the business entity you can use this identifier to collect reviews for the business entity using Tripadvisor Reviews")
    is_sponsored: Optional[StrictBool] = Field(default=None, description="indicates a sponsored placement if true, related tripadvisor_search_organic item is a paid advertising on Tripadvisor")
    reviews_count: Optional[StrictInt] = Field(default=None, description="the total number of reviews")
    category: Optional[StrictStr] = Field(default=None, description="place category")
    price_rate: Optional[StrictStr] = Field(default=None, description="average price rate")
    rating: Optional[RatingInfo] = None
    __properties: ClassVar[List[str]] = ["type", "rank_group", "rank_absolute", "title", "url_path", "is_sponsored", "reviews_count", "category", "price_rate", "rating"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TripadvisorSearchOrganicBusinessDataSerpElementItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of rating
        if self.rating:
            _dict['rating'] = self.rating.to_dict()
        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        # set to None if rank_group (nullable) is None
        # and model_fields_set contains the field
        if self.rank_group is None and "rank_group" in self.model_fields_set:
            _dict['rank_group'] = None

        # set to None if rank_absolute (nullable) is None
        # and model_fields_set contains the field
        if self.rank_absolute is None and "rank_absolute" in self.model_fields_set:
            _dict['rank_absolute'] = None

        # set to None if title (nullable) is None
        # and model_fields_set contains the field
        if self.title is None and "title" in self.model_fields_set:
            _dict['title'] = None

        # set to None if url_path (nullable) is None
        # and model_fields_set contains the field
        if self.url_path is None and "url_path" in self.model_fields_set:
            _dict['url_path'] = None

        # set to None if is_sponsored (nullable) is None
        # and model_fields_set contains the field
        if self.is_sponsored is None and "is_sponsored" in self.model_fields_set:
            _dict['is_sponsored'] = None

        # set to None if reviews_count (nullable) is None
        # and model_fields_set contains the field
        if self.reviews_count is None and "reviews_count" in self.model_fields_set:
            _dict['reviews_count'] = None

        # set to None if category (nullable) is None
        # and model_fields_set contains the field
        if self.category is None and "category" in self.model_fields_set:
            _dict['category'] = None

        # set to None if price_rate (nullable) is None
        # and model_fields_set contains the field
        if self.price_rate is None and "price_rate" in self.model_fields_set:
            _dict['price_rate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TripadvisorSearchOrganicBusinessDataSerpElementItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "rank_group": obj.get("rank_group"),
            "rank_absolute": obj.get("rank_absolute"),
            "title": obj.get("title"),
            "url_path": obj.get("url_path"),
            "is_sponsored": obj.get("is_sponsored"),
            "reviews_count": obj.get("reviews_count"),
            "category": obj.get("category"),
            "price_rate": obj.get("price_rate"),
            "rating": RatingInfo.from_dict(obj["rating"]) if obj.get("rating") is not None else None
        })
        return _obj


